/* TsCutter */

#include <stdio.h>

#include <io.h>			/* _openA_closeA_readA_writeA_lseeki64 `Ă */
#include <fcntl.h>		/* _O_BINARYA_O_RDONLYA_O_SEQUENTIALA_O_WRONLYA_O_CREATEA_O_TRUNC `Ă */
#include <sys/stat.h>	/* _S_IREADA_S_IWRITE `Ă */

int main(int argc,char *argv[]) {
	FILE *fp1,*fp2;
	int fd1,fd2;
	char basename[512],gopname[512],logname[512],name[512],buf[1024],str[32][1024];
	int i,j,col,hour,min,sec,ms,count;
	long line,start,offset[64],current,div,packet[64],syncerr,formerr,tranerr,droperr,scrambl,nodata,cuttime,prevtime,prevpacket,nowpacket,endtime,packetsize;
	long rc;
	__int64 seekpoint,pdata,psize;

	/* Ȃꍇ̓wv\ďI */
	if(argc<2) {
		printf("usage: %s <TS-file> [div-time [cut-time] | -r | -rf | -rr]\n",argv[0]);
		return -1;
	}

	/* 2ȏ̈ꍇ́A2ڂ؂oԂƂ */
	div=0;
	cuttime=0;
	if(argc>2) {
		/* -rnIvVw肳Ăꍇ́A؂oԂ͎włȂ */
		if(strcmp(argv[2],"-r")==0) div=-1;
		else {
			if(strcmp(argv[2],"-rf")==0) div=-2;
			else {
				if(strcmp(argv[2],"-rr")==0) div=-3;
				else {
					i=sscanf(argv[2],"%d:%d:%d:%d",&hour,&min,&sec,&ms);
					div=hour*3600000+min*60000+sec*1000+ms;
					/* 3ȏ̈ꍇ́A3ڂ؂oJnʒuƂ */
					if(argc>3) {
						i=sscanf(argv[3],"%d:%d:%d:%d",&hour,&min,&sec,&ms);
						cuttime=hour*3600000+min*60000+sec*1000+ms;
/* hour=cuttime/3600000; */
/* min=(cuttime-(hour*3600000))/60000; */
/* sec=(cuttime-(hour*3600000)-(min*60000))/1000; */
/* ms=cuttime-(hour*3600000)-(min*60000)-(sec*1000); */
/* printf("DEBUG: cuttime = %02d:%02d:%02d:%03d (%ld)\n",hour,min,sec,ms,cuttime); */
					}
				}
			}
		}
	}

	/* TSt@CgqȂ̂߂ */
	strcpy(basename,argv[1]);
	i=strlen(basename);
	while(basename[--i]!='.'&&i>0);
	basename[i]='\0';
/* printf("DEBUG: basename = %s\n",basename); */

	/* TSt@C啔ɂ͍ő36ǉ邱Ƃz肵475𒴂G[ */
	if(i>475) {
		printf("ts file name is long.\n");
		return -1;
	}

	/* u)vŏIt@C̓l[ςƂăG[i-rIvV̂݁j */
	if(div==-1) {
		if(basename[i-1]==')') {
			printf("this file is renamed.\n",argv[1]);
			return -1;
		}
	}

	/* GOPt@CJȂꍇ́AG[\ďI */
	strcpy(gopname,basename);
	strcat(gopname,".ts.txt");
	fp1=fopen(gopname,"r");
	if(fp1==NULL) {
		printf("%s is not open.\n",gopname);
		return -1;
	}

	/* GOPt@C1sǂݍށiC[vj */
	start=0;
	prevtime=0;
	prevpacket=0;
	count=0;
	nodata=0;
	line=0;
	while(fgets(buf,1024,fp1)!=NULL) {

		/* 1s̒1024ȏȂAG[\ďI */
		i=strlen(buf);
		if(i!=0 && buf[i-1]!='\n') {
			printf("line size 1024 over.\n");
			return -1;
		}

		/* ̉sR[h폜 */
		buf[i-1]='\0';

		/* 1sCSVƂĕzɓǂݍ */
		col=0;
		i=0;
		while(buf[i]!='\0') {
			j=0;
			/* J}sɂȂ܂ŌJԂ */
			while(buf[i]!='\0' && buf[i]!=',') {
				str[col][j]=buf[i];
				j++;
				i++;
			}
			str[col][j]='\0';
			col++;
			i++;
		}

		/* 1s5JŁA2Jڂ6ȏȂL */
		i=strlen(str[1]);
		if(col==5) {
			if(i>6) {
				/* 2Jڂ̖u)vȂ特ch񂪂Ɣ */
				if(str[1][i-1]!=')') {
					/* Ԃǂݍށich񖳂j */
					i=sscanf(str[1],"%d:%d:%d:%d",&hour,&min,&sec,&ms);
				}
				else {
					/* 2Jڂ̐擪uCvȂ特ch̃f[^Ɣ */
					if(str[1][0]!='C') {
						/* Ԃǂݍށichf[^j */
						i=sscanf(str[1],"(%d:%d:%d:%d)",&hour,&min,&sec,&ms);
					}
					else {
						/* Ԃǂݍ */
						i=sscanf(str[1],"Ch%d(%d:%d:%d:%d)",&j,&hour,&min,&sec,&ms);
					}
				}
				current=hour*3600000+min*60000+sec*1000+ms;
				/* 5JڂpPbgʒuƂēǂݍ */
				i=sscanf(str[4],"%ld",&nowpacket);

				/* Lȃf[^1sڂȂԂJnԂƂĕۑ */
				if(line==0) {
					start=current;
					prevtime=0;
					prevpacket=0;
					count=0;
/* hour=current/3600000; */
/* min=(current-(hour*3600000))/60000; */
/* sec=(current-(hour*3600000)-(min*60000))/1000; */
/* ms=current-(hour*3600000)-(min*60000)-(sec*1000); */
/* printf("start %02d:%02d:%02d:%03d (%ld) / %ld\n",hour,min,sec,ms,current,nowpacket); */
				}
				/* JnʒuƓĂ邩H */
				if((current-start)==cuttime && count==0) {
					offset[count]=current;
					/* cutimew肳ĂȂ0̏ꍇ͐擪JnʒuƂ */
					if(cuttime==0) packet[count]=0;
					else packet[count]=nowpacket;
/* hour=offset[count]/3600000; */
/* min=(offset[count]-(hour*3600000))/60000; */
/* sec=(offset[count]-(hour*3600000)-(min*60000))/1000; */
/* ms=offset[count]-(hour*3600000)-(min*60000)-(sec*1000); */
/* printf("(%03d) %02d:%02d:%02d:%03d (%ld) / %ld\n",count,hour,min,sec,ms,offset[count],packet[count]); */
					count++;
				}
				else {
					if((current-start)>cuttime && count==0) {
						offset[count]=prevtime;
						packet[count]=prevpacket;
/* hour=offset[count]/3600000; */
/* min=(offset[count]-(hour*3600000))/60000; */
/* sec=(offset[count]-(hour*3600000)-(min*60000))/1000; */
/* ms=offset[count]-(hour*3600000)-(min*60000)-(sec*1000); */
/* printf("(%03d) %02d:%02d:%02d:%03d (%ld) / %ld\n",count,hour,min,sec,ms,offset[count],packet[count]); */
						count++;
					}
				}
				/* ԂƓĂ邩H */
				if((current-offset[count-1])>=div && count>0 && div>0) {
					offset[count]=current;
					packet[count]=nowpacket;
/* hour=offset[count]/3600000; */
/* min=(offset[count]-(hour*3600000))/60000; */
/* sec=(offset[count]-(hour*3600000)-(min*60000))/1000; */
/* ms=offset[count]-(hour*3600000)-(min*60000)-(sec*1000); */
/* printf("(%03d) %02d:%02d:%02d:%03d (%ld) / %ld\n",count,hour,min,sec,ms,offset[count],packet[count]); */
					count++;
				}
				/* 1O̕ԂƃpPbgʒuۑ */
				prevtime=current;
				prevpacket=nowpacket;

				/* Lȃf[^̍sJEg */
				line++;
			}
			else {
				/* Ԃ̊܂܂ȂGOPf[^̐JEg */
				nodata++;
			}
		}
		/* 1JڂuTSPAC_TYPEvŎn܂Ȃ2JڂpPbgTCYƂēǂݍ */
		if(strncmp(str[0],"TSPAC_TYPE",10)==0) i=sscanf(str[1],"%ld",&packetsize);
		/* 1JڂuLASTvŎn܂Ȃ2Jڂ𖖔pPbgʒuƂēǂݍ */
		if(strncmp(str[0],"LAST",4)==0) {
			offset[count]=99*3600000+59*60000+59*1000+999;	/* Ԃ͔Ȃ̂99:59:59:999Ƃ */
			i=sscanf(str[1],"%ld",&packet[count]);
/* hour=offset[count]/3600000; */
/* min=(offset[count]-(hour*3600000))/60000; */
/* sec=(offset[count]-(hour*3600000)-(min*60000))/1000; */
/* ms=offset[count]-(hour*3600000)-(min*60000)-(sec*1000); */
/* printf("(%03d) %02d:%02d:%02d:%03d (%ld) / %ld\n",count,hour,min,sec,ms,offset[count],packet[count]); */
		}
	}

	/* GOPt@C */
	fclose(fp1);

	/* Lȃf[^ꌏΏI */
	if(line==0) {
		printf("no data GOP file.\n");
		return -1;
	}

/* hour=current/3600000; */
/* min=(current-(hour*3600000))/60000; */
/* sec=(current-(hour*3600000)-(min*60000))/1000; */
/* printf("DEBUG: (1) rectime(current) = %02d:%02d:%02d\n",hour,min,sec); */

	/* 擪GOPJnʒu疖GOPJnʒu܂ł̎Ԃ߂ */
	endtime=current;
	current=current-start;
	/* LȂf[^iGOPj1ɂA0.5bƌvZĒǉ */
	nodata++;	/* GOPf[^1ƂăJEg */
	current=current+(nodata*500);

/* hour=current/3600000; */
/* min=(current-(hour*3600000))/60000; */
/* sec=(current-(hour*3600000)-(min*60000))/1000; */
/* printf("DEBUG: (2) rectime(current) = %02d:%02d:%02d\n",hour,min,sec); */

	/* ^掞Ԃ\ */
	if(div==0) {
		hour=current/3600000;
		min=(current-(hour*3600000))/60000;
		sec=(current-(hour*3600000)-(min*60000))/1000;
		printf("%02d:%02d:%02d",hour,min,sec);	/* ^掞 */
		hour=start/3600000;
		min=(start-(hour*3600000))/60000;
		sec=(start-(hour*3600000)-(min*60000))/1000;
		ms=start-(hour*3600000)-(min*60000)-(sec*1000);
		printf(" (%02d:%02d:%02d:%03d",hour,min,sec,ms); /* ^Jn */
		hour=endtime/3600000;
		min=(endtime-(hour*3600000))/60000;
		sec=(endtime-(hour*3600000)-(min*60000))/1000;
		ms=endtime-(hour*3600000)-(min*60000)-(sec*1000);
		printf("-%02d:%02d:%02d:%03d)\n",hour,min,sec,ms); /* ^I */
	}

/* hour=current/3600000; */
/* min=(current-(hour*3600000))/60000; */
/* sec=(current-(hour*3600000)-(min*60000))/1000; */
/* printf("DEBUG: (3) rectime(current) = %02d:%02d:%02d\n",hour,min,sec); */

	/* JnʒuȂΏI */
	if(count==0 && div>0) {
		printf("cut start time not found.\n");
		return -1;
	}

/* fd1=_open(argv[1],_O_BINARY|_O_RDONLY|_O_SEQUENTIAL); */
/* if(fd1<0) { */
/*	printf("fopen error. %s\n",argv[1]); */
/*	return -1; */
/* } */
/* rc=_lseeki64(fd1,0,SEEK_END); */
/* if(rc==-1L) { */
/*	printf("fseek error.\n"); */
/* } */
/* seekpoint=_telli64(fd1); */
/* printf("ftell = %I64d\n",seekpoint); */
/* _close(fd1); */

	/* ӏ̃f[^TSt@C̕Jn */
	if(div>0) {

		/* cuttimew肳Ăꍇ͕1ɂ */
		if(argc>3) count=1;

		/* TSt@CJȂꍇ́AG[\ďI */
/*		fp1=fopen(argv[1],"rb");	*/
		fd1=_open(argv[1],_O_BINARY|_O_RDONLY|_O_SEQUENTIAL);
/*		if(fp1==NULL) {	*/
		if(fd1<0) {
			printf("%s is not binary read open.\n",argv[1]);
			return -1;
		}

		for(i=0;i<count;i++) {
			/* TSt@Co */
			sprintf(name,"%s_%03d.ts",basename,i+1);
			pdata=packet[i];
			psize=packetsize;
/* hour=offset[i]/3600000; */
/* min=(offset[i]-(hour*3600000))/60000; */
/* sec=(offset[i]-(hour*3600000)-(min*60000))/1000; */
/* ms=offset[i]-(hour*3600000)-(min*60000)-(sec*1000); */
/* printf("DEBUG: time=%02d:%02d:%02d:%03d (%ld) packet=%I64d size=%I64d name=%s\n",hour,min,sec,ms,offset[i],pdata,psize,name); */

/*			fp2=fopen(name,"wb");	*/
			fd2=_open(name,_O_WRONLY|_O_BINARY|_O_CREAT|_O_TRUNC,_S_IREAD|_S_IWRITE);
/*			if(fp2==NULL) {	*/
			if(fd2<0) {
				printf("%s is not binary write open.\n",name);
				return -1;
			}
/* seekpoint=_telli64(fd1); */
/* printf("DEBUG: seek before ftell %I64d\n",seekpoint); */
			seekpoint=pdata*psize;
/* printf("DEBUG: fseek %I64d\n",seekpoint); */
/*			j=fseek(fp1,seekpoint,SEEK_SET); */
			rc=_lseeki64(fd1,seekpoint,SEEK_SET);
/*			if(j!=0) {	*/
			if(rc==-1L) {
				printf("fseek error.\n");
				return -1;
			}
/* seekpoint=_telli64(fd1); */
/* printf("DEBUG: seek after  ftell %I64d\n",seekpoint); */
			for(j=0;j<(packet[i+1]-packet[i]);j++) {
/*				fread(buf,1,packetsize,fp1);	*/
				_read(fd1,buf,packetsize);
/*				fwrite(buf,1,packetsize,fp2);	*/
				_write(fd2,buf,packetsize);

			}

			/* TSt@C */
/*			fclose(fp2);	*/
			_close(fd2);
		}
		/* TSt@C */
/*		fclose(fp1);	*/
		_close(fd1);
	}

	/* -r y -rf IvVw肳Ăꍇ̏ */
	if(div<0) {
		/* Multi2Dec̃Ot@CJꍇ̂ݏs */
		syncerr=0;
		formerr=0;
		tranerr=0;
		droperr=0;
		scrambl=0;
		strcpy(logname,basename);
		strcat(logname,"_dec.txt");
/* printf("DEBUG: logname = %s\n",logname); */
		fp1=fopen(logname,"r");
		if(fp1!=NULL) {
			while(fgets(buf,1024,fp1)!=NULL) {
				/* J}苎 */
				i=0;
				j=0;
				while(buf[i]!='\0') {
					buf[j]=buf[i];
					if(buf[i]!=',') j++;
					i++;
				}
				/* eG[̒lǂݍ */
				if(strncmp(buf,"Sync Error       :",18)==0) i=sscanf(buf,"Sync Error       :%ld",&syncerr);
				if(strncmp(buf,"Format Error     :",18)==0) i=sscanf(buf,"Format Error     :%ld",&formerr);
				if(strncmp(buf,"Transport Error  :",18)==0) i=sscanf(buf,"Transport Error  :%ld Packet",&tranerr);
				if(strncmp(buf,"Total Drop Error :",18)==0) i=sscanf(buf,"Total Drop Error :%ld Packet",&droperr);
				if(strncmp(buf,"Total Scrambling :",18)==0) i=sscanf(buf,"Total Scrambling :%ld Packet",&scrambl);
			}
			/* fopen łȂt@C fclose ƃnOAbv */
			fclose(fp1);
		}

/* printf("DEBUG: before basename = %s\n",basename); */
		/* u (vOt@C啔Ƃi-rr IvVw莞j */
		if(div==-3) {
			/* u)vH */
			i=strlen(basename);
			if(basename[i-1]==')') {
				/* OɁu (v邩H */
				while(basename[i]!=' ' && i>0) i--;
				if(basename[i]==' ' && basename[i+1]=='(') {
					/* u (v̈ʒuL */
					j=i;
					/* Ɂu)v͂邩H */
					while(basename[i]!=')' && basename[i]!='\0') i++;
					if(strncmp(basename+i-2,"",2)==0) {
						/* u (vȍ~؂̂Ă */
						basename[j]='\0';
					}
					/* Ɂumin)v͂邩H */
					if(strncmp(basename+i-3,"min",3)==0) {
						/* u (vȍ~؂̂Ă */
						basename[j]='\0';
					}
				}
			}
		}
/* printf("DEBUG: after basename = %s\n",basename); */

/* hour=current/3600000; */
/* min=(current-(hour*3600000))/60000; */
/* sec=(current-(hour*3600000)-(min*60000))/1000; */
/* printf("DEBUG: (4) rectime(current) = %02d:%02d:%02d\n",hour,min,sec); */

		/* ~b͐؂̂ */
		hour=current/3600000;
		min=(current-(hour*3600000))/60000;
		sec=(current-(hour*3600000)-(min*60000))/1000;
		/* b͎ľܓ */
		if(sec>29) min++;
		sec=0;
		/* Pʂɕϊ */
		current=min+(hour*60);

		/* l[pt@C쐬 */
		if(droperr>0) {
			sprintf(buf,"%s (%ld)(Drop=%ld)",basename,current,droperr);	/* hbv */
		}
		else {
			if(syncerr>0 || formerr >0 || tranerr>0) {
				sprintf(buf,"%s (%ld)(Error)",basename,current);	/* hbvȊÕG[L */
			}
			else {
				if(scrambl>0) {
					sprintf(buf,"%s (%ld)(Scramble)",basename,current); /* XNuL */
				}
				else {
					sprintf(buf,"%s (%ld)",basename,current); /* G[ */
				}
			}
		}

		/* TSt@C̃l[s */
		strcpy(name,buf);
		strcat(name,".ts");
		i=rename(argv[1],name);
		if(i!=0) {
			printf("TS file rename error.\n");
		}
		/* GOPt@C̃l[s */
		strcpy(name,buf);
		strcat(name,".ts.txt");
		i=rename(gopname,name);
		if(i!=0) {
			printf("GOP file rename error.\n");
		}
		/* Ot@C̃l[s */
		strcpy(name,buf);
		strcat(name,"_dec.txt");
		i=rename(logname,name);
		if(i!=0) {
			printf("LOG file rename error.\n");
		}
	}

	return 0;
}
